import pygame, sys
from pygame.locals import *
from colors import colors
from random import randint
class Ghost(pygame.sprite.Sprite):
    def __init__(self, pos_x, pos_y, x, y, speed, scale, image):
        super().__init__()
        self.picture = image
        self.image = image
        self.image = pygame.transform.scale(self.image, (scale, scale))
        self.rect = self.image.get_rect()
        self.rect.x = pos_x
        self.rect.y = pos_y
        self.pos_x = pos_x
        self.pos_y = pos_y
        self.scale = scale
        self.time = 0
        self.timer = 2000
        self.hearts = 1
        self.hearts_backup = 1
        self.game = None
        self.x = x
        self.y = y
        self.old_x = x
        self.old_y = y
        self.state = 1
        self.direction = ""
        self.directions_possible = []
        self.last_direction = self.direction
        self.speed = speed
        self.left = False
        self.right = False
        self.down = False
        self.up = False
        self.movement_timer = 0
        self.movement_time = 100
    def reset(self):
        self.directions_possible = []
        self.rect.x = self.pos_x
        self.rect.y = self.pos_y
        self.x = self.old_x
        self.y = self.old_y
    def respawn(self):
        if self.game.time - self.time > self.timer:
            self.hearts = self.hearts_backup    
            self.game.ghosts.append(self)    
            self.game.all_sprites.add(self)
            self.reset()
    def movement(self, left, right, down, up):
        right = False
        if self.game.window.get_at((self.rect.x+self.scale, self.rect.y+self.speed)) == colors.black:
            if self.game.window.get_at((self.rect.x+self.scale, self.rect.y+self.scale-self.speed)) == colors.black:
                right = True
        left = False
        if self.game.window.get_at((self.rect.x-self.speed, self.rect.y+self.speed)) == colors.black:
            if self.game.window.get_at((self.rect.x-self.speed, self.rect.y+self.scale-self.speed)) == colors.black:
                left = True
        down = False
        if self.game.window.get_at((self.rect.x+self.speed, self.rect.y+self.scale+self.speed)) == colors.black:
            if self.game.window.get_at((self.rect.x+self.scale-self.speed, (self.rect.y+self.scale+self.speed))) == colors.black:
                self.x = int(self.x+0.5)
                down = True
        up = False
        if self.game.window.get_at((self.rect.x+self.speed, self.rect.y-self.speed)) == colors.black:
            if self.game.window.get_at((self.rect.x+self.scale-self.speed, self.rect.y-self.speed)) == colors.black:
                up = True
        self.left = left
        self.right = right
        self.down = down
        self.up = up
    def anti_direction(self, string):
        if string=="right":
            if self.direction == "left":
                return True
            else:
                return False
        elif string=="left":
            if self.direction == "right":
                return True
            else:
                return False
        elif string=="up":
            if self.direction == "down":
                return True
            else:
                return False
        elif string=="down":
            if self.direction == "up":
                return True
            else:
                return False
    def normal_movement(self):
        self.directions_possible.clear()
        if self.right == True:
            self.directions_possible.append("right")
        if self.left == True:
            self.directions_possible.append("left")
        if self.down == True:
            self.directions_possible.append("down")
        if self.up == True:
            self.directions_possible.append("up")
        for direction in self.directions_possible:
            """if direction == self.last_direction:
                self.directions_possible.remove(direction)
                break"""
            if self.anti_direction(direction) == True:
                self.directions_possible.remove(direction)
        if len(self.directions_possible) > 0:
            if self.game.time-self.movement_timer > self.movement_time:
                x = randint(0, len(self.directions_possible)-1)
                if self.directions_possible[x] != self.direction: 
                    self.last_direction = self.direction
                self.movement_timer = self.game.time
                self.direction = self.directions_possible[x]
    def move(self):
        if self.direction == "right":
            if self.right == True:
                self.x += self.speed/self.game.pixel
            else:
                self.last_direction = self.direction
                self.direction = ""
        elif self.direction == "left":
            if self.left == True:
                self.x -= self.speed/self.game.pixel
            else:
                self.last_direction = self.direction
                self.direction = ""
        elif self.direction == "up":
            if self.up == True:
                self.y -= self.speed/self.game.pixel
            else:
                self.last_direction = self.direction
                self.direction = ""
        elif self.direction == "down":
            if self.down == True:
                self.y += self.speed/self.game.pixel
            else:
                self.last_direction = self.direction
                self.direction = ""
    def update(self):
        self.rect.x = int(self.x*self.game.pixel+0.5)
        self.rect.y = int(self.y*self.game.pixel+0.5)
        if self.direction == "":
            if int(self.x+0.5) - self.x > 0:
                self.x = int(self.x+0.5)
            if int(self.y+0.5) - self.y > 0:
                self.y = int(self.y+0.5)
        self.movement(self.left, self.right, self.down, self.up)
        if self.state == 1:
            self.normal_movement()
        self.move()
        if self.direction == "left":
            if self.rect.x < self.game.pixel:
                self.x = self.game.levels.len_x-2
                self.rect.x = int(self.x*self.game.pixel+0.5)
        elif self.direction == "right":
            if self.rect.x > self.game.width-int(self.game.pixel*2):
                self.x = 1
                self.rect.x = int(self.x*self.game.pixel+0.5)
if __name__ == "__main__":
    sys.exit()