import pygame, sys
from pygame.locals import *
from organization import Game
from colors import colors
from random import randint
pygame.init()
if __name__ == "__main__":
    game = Game()
    game.update()
while True:
    game.time = pygame.time.get_ticks()
    if game.state == 1:
        game.window.fill(game.background_color)
        game.window.blit(game.text_menu, game.text_menu_pos)
        game.window.blit(game.text_menu2, game.text_menu2_pos)
        if game.time - game.timer > game.menu_anim:
            game.timer = pygame.time.get_ticks()
            if game.text_menu_color != colors.black:
                game.text_menu = game.font_start.render("Press any key to start", True, colors.black)
                game.text_menu_color = colors.black
            elif game.text_menu_color == colors.black:
                game.text_menu = game.font_start.render("Press any key to start", True, colors.white)
                game.text_menu_color = colors.white
    if game.state == 2:
        pygame.display.set_caption("fps: "+str(round(game.clock.get_fps(), 1))+" level: "+str(game.level)+" points: "+str(game.points))
        game.window.fill(game.background_color)
        game.clock.tick(game.fps)
        for tile in game.tiles:
            pygame.draw.rect(game.window, tile.color, tile.rect)
        for ghost in game.ghost_backup:
            if ghost.hearts == 0:
                ghost.respawn()
        game.all_sprites.update()
        game.all_sprites.draw(game.window)
    if game.state == 3:
        game.window.fill((game.background_color))
        game.window.blit(game.text_game_over, game.text_game_over_pos)
        game.window.blit(game.text_game_over2, game.text_game_over2_pos)
        game.text_game_over3 = game.font_start.render("Points: "+str(game.points_backup), True, colors.white)
        game.text_game_over3_pos = game.text_game_over3.get_rect(center=(game.width/2, game.height/2+120))
        game.window.blit(game.text_game_over3, game.text_game_over3_pos)
        if game.time - game.timer > game.menu_anim:
            game.timer = pygame.time.get_ticks()
            if game.text_game_over_color != colors.black:
                game.text_game_over = game.font_start.render("You reached level "+str(game.level), True, colors.black)
                game.text_game_over_color = colors.black
            elif game.text_game_over_color == colors.black:
                game.text_game_over = game.font_start.render("You reached level "+str(game.level), True, colors.white)
                game.text_game_over_color = colors.white
    if game.state > 0:
        pygame.display.update()
        for event in pygame.event.get():
            if event.type == KEYDOWN:
                if game.state == 1:
                    game.update()
                if game.state == 3:
                    game.state = 1
                    game.update()
                elif game.state == 2:
                    if event.key == K_r:
                        game.points = 0
                        game.ghosts.clear()
                        game.coins.clear()
                        game.power_ups.clear()
                        game.player.reset()
                        game.level = 1
                        for ghost in game.ghosts:
                            ghost.reset()
                    if event.key == K_ESCAPE:
                        game.state = 0
                        game.update()
            if event.type == MOUSEBUTTONDOWN:
                if game.state == 1:
                    game.update()
                elif game.state == 2:
                    game.points = 0
                    game.ghosts.clear()
                    game.coins.clear()
                    game.power_ups.clear()
                    game.player.reset()
                    game.level = 1
                    for ghost in game.ghosts:
                        ghost.reset()
                elif game.state == 3:
                    game.state = 1
                    game.update()
            if event.type == QUIT:
                pygame.quit()
                sys.exit()