import pygame, sys
from pygame.locals import *
from colors import colors
class Player(pygame.sprite.Sprite):
    def __init__(self, pos_x, pos_y, speed, time, scale, x, y, image, hearts):
        super().__init__()
        self.picture = image
        self.picture2 = pygame.image.load("sprites/player_an1.png")
        self.image = self.picture
        self.image = pygame.transform.scale(self.image, (scale, scale))
        self.img = "static"
        self.rect = self.image.get_rect()
        self.rect.x = pos_x
        self.rect.y = pos_y
        self.pos_x = pos_x
        self.pos_y = pos_y
        self.scale = scale
        self.x = x
        self.y = y
        self.old_x = x
        self.old_y = y
        self.check_x = x
        self.check_y = y
        self.speed = speed
        self.direction = ""
        self.future_direction = ""
        self.game = None
        self.time = time
        self.timer = pygame.time.get_ticks()
        self.power_timer = 0
        self.horizontal = ["right", "left"]
        self.vertical = ["up", "down"]
        self.up = True
        self.left = True
        self.down = True
        self.right = True
        self.state = 1
        self.hearts = hearts
        self.heart_backup = hearts
        self.power_len = 5000
    def reset(self):
        self.hearts = self.heart_backup
        self.rect.x = self.pos_x
        self.rect.y = self.pos_y
        self.x = self.old_x
        self.y = self.old_y
        self.future_direction = ""
        self.direction = ""
        self.state = 1
        self.game.all_sprites.empty()
        for coin in self.game.coin_backup:
            self.game.all_sprites.add(coin)
            self.game.coins.append(coin)
        for power_up in self.game.power_up_backup:
            self.game.all_sprites.add(power_up)
            self.game.power_ups.append(power_up)
        for ghost in self.game.ghost_backup:
            self.game.all_sprites.add(ghost)
            self.game.ghosts.append(ghost)
        self.game.all_sprites.remove(self)
        self.game.all_sprites.add(self)
    def movement(self, keys, up, left, down, right):
        self.check_x = int(self.x)
        self.check_y = int(self.y)
        if keys[K_w] or keys[K_UP]:
            self.future_direction = "up"
        elif keys[K_a] or keys[K_LEFT]:
            self.future_direction = "left"
        elif keys[K_s] or keys[K_DOWN]:
            self.future_direction = "down"
        elif keys[K_d] or keys[K_RIGHT]:
            self.future_direction = "right"
        if self.future_direction == "up":
            if self.game.window.get_at((self.rect.x+1, self.rect.y-self.speed)) == colors.black:
                if self.game.window.get_at((self.rect.x+self.scale-1, self.rect.y-self.speed)) == colors.black:
                    self.direction = "up"
                    self.future_direction = ""
        if self.direction == "up":
            up = False
            if self.game.window.get_at((self.rect.x+self.speed, self.rect.y-self.speed)) == colors.black:
                if self.game.window.get_at((self.rect.x+self.scale-self.speed, self.rect.y-self.speed)) == colors.black:
                    up = True
        if self.future_direction == "down":
            if self.game.window.get_at((self.rect.x+self.speed, self.rect.y+self.scale+self.speed)) == colors.black:
                if self.game.window.get_at((self.rect.x+self.scale-self.speed, self.rect.y+self.scale+self.speed)) == colors.black:
                    self.direction = "down"
                    self.x = int(self.x+0.5)
                    self.future_direction = ""
        if self.direction == "down":
            down = False
            if self.game.window.get_at((self.rect.x+self.speed, self.rect.y+self.scale+self.speed)) == colors.black:
                if self.game.window.get_at((self.rect.x+self.scale-self.speed, (self.rect.y+self.scale+self.speed))) == colors.black:
                    self.x = int(self.x+0.5)
                    down = True
        if self.future_direction == "right":
            if self.game.window.get_at((self.rect.x+self.scale, self.rect.y+self.speed)) == colors.black:
                if self.game.window.get_at((self.rect.x+self.scale, self.rect.y+self.scale-self.speed)) == colors.black:
                    self.y = int(self.y+0.5)
                    self.direction = "right"
                    self.future_direction = ""
        if self.direction == "right":
            right = False
            if self.game.window.get_at((self.rect.x+self.scale, self.rect.y+self.speed)) == colors.black:
                if self.game.window.get_at((self.rect.x+self.scale, self.rect.y+self.scale-self.speed)) == colors.black:
                    right = True
        if self.future_direction == "left":
            if self.game.window.get_at((self.rect.x-self.speed, self.rect.y+self.speed)) == colors.black:
                if self.game.window.get_at((self.rect.x-self.speed, self.rect.y+self.scale-self.speed)) == colors.black:
                    self.y = int(self.y+0.5)
                    self.direction = "left"
                    self.future_direction = ""
        if self.direction == "left":
            left = False
            if self.game.window.get_at((self.rect.x-self.speed, self.rect.y+self.speed)) == colors.black:
                if self.game.window.get_at((self.rect.x-self.speed, self.rect.y+self.scale-self.speed)) == colors.black:
                    left = True
        if self.direction == "up":
            if up == True:
                self.y -= self.speed/self.game.pixel
            else:
                self.direction = ""
        if self.direction == "down":
            if down == True:
                self.y += self.speed/self.game.pixel
            else:
                self.direction = ""
        if self.direction == "right":
            if right == True:
                self.x += self.speed/self.game.pixel
            else:
                self.direction = ""
        if self.direction == "left":
            if left == True:
                self.x -= self.speed/self.game.pixel
            else:
                self.direction = ""
    def collisions(self):
        for coin in self.game.coins:
            if self.rect.colliderect(coin.rect):
                self.game.points+=10
                self.game.all_sprites.remove(coin)
                self.game.coins.remove(coin)
        for power_up in self.game.power_ups:
            if self.rect.colliderect(power_up.rect):
                self.game.all_sprites.remove(power_up)
                self.game.power_ups.remove(power_up)
                self.state = 2
                self.power_timer = pygame.time.get_ticks()
        for ghost in self.game.ghosts:
            if self.rect.colliderect(ghost.rect):
                if self.state == 1:
                    self.hearts-=1
                    if self.hearts > 0:
                        self.direction = ""
                        self.future_direction = ""
                        self.rect.x = self.pos_x
                        self.rect.y = self.pos_y
                        self.x = self.old_x
                        self.y = self.old_y
                    else:
                        self.game.all_sprites.remove(self)
                        self.game.state = 3
                elif self.state == 2:
                    self.game.points+=50
                    ghost.hearts-=1
                    self.game.all_sprites.remove(ghost)
                    self.game.ghosts.remove(ghost)
                    ghost.time = pygame.time.get_ticks()
        if len(self.game.coins) == 0:
            self.game.level+=1
            self.reset()
        if self.hearts == 0:
            self.game.level = 1
            self.game.state = 3
            self.game.all_sprites.empty()
            self.game.coins.clear()
            self.game.power_ups.clear()
            self.game.ghosts.clear()
            self.game.update()
    def animation(self):
        if self.state == 1:
            if self.img != "static":
                self.img = "static"
                self.image = self.picture
                self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
        if self.state == 2:
            if self.img == "static":
                self.img = "an_1"
                self.image = self.picture2
                self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
    def power_up(self):
        if self.game.time - self.power_timer > self.power_len:
            self.state = 1
            self.img = "static"
            self.image = self.picture
            self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
    def update(self):
        keys = pygame.key.get_pressed()
        self.movement(keys, self.up, self.left, self.down, self.right)
        self.rect.x = int(self.x*self.game.pixel+0.5)
        self.rect.y = int(self.y*self.game.pixel+0.5)
        self.collisions()
        if self.direction == "left":
            if self.rect.x < self.game.pixel:
                self.x = self.game.levels.len_x-2
                self.rect.x = int(self.x*self.game.pixel+0.5)
        elif self.direction == "right":
            if self.rect.x > self.game.width-int(self.game.pixel*2):
                self.x = 1
                self.rect.x = int(self.x*self.game.pixel+0.5)
        self.animation()
        if self.state == 2:
            self.power_up()
        if self.direction == "":
            if int(self.x+0.5) - self.x > 0:
                self.x = int(self.x+0.5)
            if int(self.y+0.5) - self.y > 0:
                self.y = int(self.y+0.5)
        #print(self.future_direction)
        #print("x: ", self.x)
        #print("y: ", self.y)
if __name__ == "__main__":
    sys.exit()